#include <iostream>
#include <cmath>
#include <string>

using namespace std;

int main() {
	int n, o, a, b, ab;
	int f = 0;
	string grupa[10001];
	int potrebno[10001];
	int primio_o[10001], primio_a[10001], primio_b[10001], primio_ab[10001];
	
	//unos
	cin >> n;
	cin >> o >> a >> b >> ab;
	for(int i = 0; i < n; i++) {
		cin >> grupa[i] >> potrebno[i];
	}
	
	//grupa o
	for(int i = 0; i < n; i++) {
		if(grupa[i] == "O") {
			if(potrebno[i] <= o) {
				o -= potrebno[i];
				primio_o[i] = potrebno[i];
			} else
				f = 1;
		} 
	}
	
	//grupa a
	for(int i = 0; i < n; i++) {
		if(grupa[i] == "A") {
			if(potrebno[i] > a) {
				primio_a[i] = a;
				potrebno[i] -= a;
				a = 0;
			} else {
				primio_a[i] = potrebno[i];
				a -= potrebno[i];
				potrebno[i] = 0;
			}
			if(potrebno[i] > o) {
				primio_o[i] = o;
				potrebno[i] -= o;
				o = 0;
			} else {
				primio_o[i] = potrebno[i];
				o -= potrebno[i];
				potrebno[i] = 0;
			}	
		}
	}
	for(int i = 0; i < n; i++)
		if(grupa[i] == "A")
			if(potrebno[i] != 0)
				f = 1;
			
	//grupa b
	for(int i = 0; i < n; i++) {
		if(grupa[i] == "B") {
			if(potrebno[i] > b) {
				primio_b[i] = b;
				potrebno[i] -= b;
				b = 0;
			} else {
				primio_b[i] = potrebno[i];
				b -= potrebno[i];
				potrebno[i] = 0;
			}
			if(potrebno[i] > o) {
				primio_o[i] = o;
				potrebno[i] -= o;
				o = 0;
			} else {
				primio_o[i] = potrebno[i];
				o -= potrebno[i];
				potrebno[i] = 0;
			}	
		}
	}
	for(int i = 0; i < n; i++)
		if(grupa[i] == "B")
			if(potrebno[i] != 0)
				f = 1;
	
	//grupa ab
	for(int i = 0; i < n; i++) {
		if(grupa[i] == "AB") {
			if(potrebno[i] > ab) {
				primio_ab[i] = ab;
				potrebno[i] -= ab;
				ab = 0;
			} else {
				primio_ab[i] = potrebno[i];
				ab -= potrebno[i];
				potrebno[i] = 0;
			}
			if(potrebno[i] > a) {
				primio_a[i] = a;
				potrebno[i] -= a;
				a = 0;
			} else {
				primio_a[i] = potrebno[i];
				a -= potrebno[i];
				potrebno[i] = 0;
			}	
			if(potrebno[i] > b) {
				primio_b[i] = b;
				potrebno[i] -= b;
				b = 0;
			} else {
				primio_b[i] = potrebno[i];
				b -= potrebno[i];
				potrebno[i] = 0;
			}	
			if(potrebno[i] > o) {
				primio_o[i] = o;
				potrebno[i] -= o;
				o = 0;
			} else {
				primio_o[i] = potrebno[i];
				o -= potrebno[i];
				potrebno[i] = 0;
			}	
		}
	}
	for(int i = 0; i < n; i++)
		if(grupa[i] == "AB")
			if(potrebno[i] != 0)
				f = 1;
	
	//izlaz
	if(f)
		cout << "nemoguce";
	else {
		cout << "moguce";
		for(int i = 0; i < n; i++)
			cout << endl << primio_o[i] << " " << primio_a[i] << " " << primio_b[i] << " " << primio_ab[i];
	}
}